require "spring/commands/any/version"
require "spring/commands"

module Spring
  module Commands
    class Any

      def self.commands
        # Installed spring-commands-Gems, except this gem
        spring_commands = Gem::Specification
          .map(&:name)
          .grep(/^spring-commands-/)
          .map {|name| name.sub "spring-commands-", "" }
          .reject {|name| name == "any" }

        # built in commands
        binstubs = ["rails", "rake", "spring", "bundle"] + spring_commands

        Pathname.glob(Spring.application_root_path.join("{bin,script}/*"))
          .map {|path| path.basename.to_s}
          .reject {|binstub| binstub.end_with? *binstubs }
      end

      def env(args)
        RailsRunner.new.env(args)
      end

    end

    Any.commands.each do |command|
      Spring.register_command command, Any.new
    end
  end
end
